<?php
// @copyright	Copyright (C) 2010 Arhimedia Network - All rights reserved.
// @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.event.plugin');

class plgContentPhotogallery extends JPlugin
{
	//Constructor
	function plgContentPhotogallery( &$subject )
	{
		parent::__construct( $subject );
		// load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin( 'content', 'photogallery' );
		$this->_params = new JParameter( $this->_plugin->params );
	}

	function onPrepareContent(&$row, &$params, $limitstart)
	{
		// just startup
		global $mainframe;
		
		// checking
		if ( !preg_match("#{photogallery}(.*?){/photogallery}#s", $row->text) ) {
			return;
		}
		
		$plugin =& JPluginHelper::getPlugin('content', 'photogallery');
		$pluginParams = new JParameter( $plugin->params );
		
		// Parameters
		$enablejQuery = $pluginParams->get('enablejQuery', 1);
		$jQueryMode = $pluginParams->get('jQueryMode', 1);
		$images_per_row = $pluginParams->get('imagesRow', 3);
		$borderWidth = $pluginParams->get('borderWidth', 1);
		$borderColor = $pluginParams->get('borderColor', '#cccccc');
		$borderHoverColor = $pluginParams->get('borderHoverColor', '#999999');
		$thumbsMarginH = $pluginParams->get('thumbsMarginH', 10);
		$thumbsMarginV = $pluginParams->get('thumbsMarginV', 10);
		$thumbsPadding = $pluginParams->get('thumbsPadding', 3);
		$thumbs_width = $pluginParams->get('thumbsWidth', 200);
		
		if (preg_match_all("#{photogallery}(.*?){/photogallery}#s", $row->text, $matches, PREG_PATTERN_ORDER) > 0) {
			$photogallerycount = -1;
			foreach ($matches[0] as $match) {
				$photogallerycount++;
				$images_dir = preg_replace("/{.+?}/", "", $match)."/";
				$images_dir2 = preg_replace("/{.+?}/", "", $match);
				$thumbs_dir = $images_dir."thumbs/";
				
				// START gallery code
				
				/* function:  generates thumbnail */
				function make_thumb($src,$dest,$desired_width) {
					/* read the source image */
					$source_image = imagecreatefromjpeg($src);
					$width = imagesx($source_image);
					$height = imagesy($source_image);
					/* find the "desired height" of this thumbnail, relative to the desired width  */
					$desired_height = floor($height*($desired_width/$width));
					/* create a new, "virtual" image */
					$virtual_image = imagecreatetruecolor($desired_width,$desired_height);
					/* copy source image at a resized size */
					imagecopyresized($virtual_image,$source_image,0,0,0,0,$desired_width,$desired_height,$width,$height);
					/* create the physical thumbnail image to its destination */
					imagejpeg($virtual_image,$dest);
				}
				
				/* function:  returns files from dir */
				function get_files($images_dir,$exts = array('jpg')) {
					$files = array();
					if($handle = opendir($images_dir)) {
						while(false !== ($file = readdir($handle))) {
							$extension = strtolower(get_file_extension($file));
							if($extension && in_array($extension,$exts)) {
								$files[] = $file;
							}
						}
						closedir($handle);
					}
					return $files;
				}
				
				/* function:  returns a file's extension */
				function get_file_extension($file_name) {
					return substr(strrchr($file_name,'.'),1);
				}

				/** settings **/
				
				//$images_dir = 'preload-images/';
				if(!is_dir($images_dir."thumbs")) {
					mkdir($images_dir."thumbs", 0777);
				}

				//$thumbs_width = 200;
				//$images_per_row = 3;
				
				// adding CSS and JS in head
				$doc =& JFactory::getDocument();
				
				// add your stylesheet
				$doc->addStyleSheet( JURI :: base().'plugins/content/plugin_photogallery/css/jquery.lightbox-0.5.css' );
				
				// style declaration
				$doc->addStyleDeclaration( '
				
				.clear { clear:both; }
				#gallery img { margin:0px '.$thumbsMarginV.'px '.$thumbsMarginH.'px 0px; padding:'.$thumbsPadding.'px; border:'.$borderWidth.'px solid '.$borderColor.'; display:block; float:left; }
				#gallery img:hover { border-color:'.$borderHoverColor.'; }
				
				' );
				
				/** generate photo gallery **/
				if ($enablejQuery!=0) {
				echo '<script type="text/javascript" src="'.JURI :: base().'plugins/content/plugin_photogallery/js/jquery.min.js"></script>';
				}
				if ($jQueryMode!=0) {
				echo '
				<script type="text/javascript">
     				jQuery.noConflict();
				</script>
				';
				}
				echo '<script type="text/javascript" src="'.JURI :: base().'plugins/content/plugin_photogallery/js/jquery.lightbox-0.5.min.js"></script>';
				?>
                <script type="text/javascript">
					jQuery(function() {
						jQuery('#gallery a').lightBox();
					});
				</script>
                <?php
                $html = '<!-- HOT Photo Gallery Plugin starts here -->';
				$html.= '<div id="gallery">';
				$image_files = get_files($images_dir);
				if(count($image_files)) {
					$index = 0;
					foreach($image_files as $index=>$file) {
						$index++;
						$thumbnail_image = $thumbs_dir."thumb_".$file;
						if(!file_exists($thumbnail_image)) {
							$extension = get_file_extension($thumbnail_image);
							if($extension) {
								make_thumb($images_dir.$file,$thumbnail_image,$thumbs_width);
							}
						}
						$html.= '<a href="'.$images_dir.$file.'"><img src="'.$thumbnail_image.'" /></a>';
						if($index % $images_per_row == 0) { $html.= '<div class="clear"></div>'; }
					}
					$html.= '<div class="clear"></div>';
				}
				else {
					$html.= '<p>There are no images in this gallery.</p>';
				}
				$html.= '</div>';
				
				$row->text = preg_replace( "#{photogallery}".$images_dir2."{/photogallery}#s", $html , $row->text );
				
				// END gallery code
				
			}
		}
	}
}